/** myDatabase.java
  This class provides methods to access the Oracle database via JDBC
  API:
     void open()
     void findclient(String, String, Stringbuffer, Stringbuffer, Stringbuffer, Stringbuffer, Stringbuffer, Stringbuffer, Stringbuffer, Stringbuffer )
     void updateclient( String, String, String, String, String, String, String, String );
     void adddateclient( String, String, String, String, String, String, String, String );
     void delete_dateclient( String, String );
     void close ()
  Exceptions are printed.
 **/

import java.sql.*;
import java.util.Properties;

class myDatabase {
  
  private Connection conn;
  
  /**Input:void,
     Output:void,
     Function:connect to database.
  **/
  public void open() {
    try {
      Class.forName("oracle.jdbc.driver.OracleDriver");
      conn = DriverManager.getConnection
 ("jdbc:oracle:thin:@carver.npac.syr.edu:1521:europe", "gangwei", "gangwei");
      System.out.println("Connection Open");
    }
    catch (Exception e) { System.err.println("Error connection: " + e);}
  }
  
 /**Input:job and id number.
    Output:input field the result.
    Function:look for the process information from table.
 **/
  public void findclient(String last, String first, StringBuffer job, StringBuffer id, StringBuffer inputf, StringBuffer outputf, StringBuffer times, StringBuffer  timed, StringBuffer type, StringBuffer ann ) {

    try {
      System.out.println("process passed = " + last + "," + first );
      // binding input parameters to SQL call
 //     PreparedStatement pstmt = conn.prepareStatement("select * from process_idtable where last_name = ? and first_name = ?");
      PreparedStatement pstmt = conn.prepareStatement("select * from process_idtable where id = ?");

      pstmt.setInt(1, Integer.parseInt( first ));
//      pstmt.setString( 2, first );
     // Execute the SQL, ResultSet is row(s) of data returned by database query
      ResultSet rs = null;
      rs = pstmt.executeQuery();
      // return the fields of the first row of the result set      
      rs.next(); 

      job.append(rs.getString( 1 ));	
      id.append(rs.getInt( 2 ));
      inputf.append(rs.getString( 3 ) );
      outputf.append(rs.getString( 4 ) );
      times.append(rs.getString( 5 ) );
      timed.append(rs.getString( 6 ) );
      type.append(rs.getString( 7 ) );
      ann.append(rs.getString( 8 ) );
      // closing statement
      pstmt.close(); 
    }
    catch (Exception e) {
      System.err.println("Error in dbase");
      e.printStackTrace();
    }

  }	
  

 /**Input:job, id, input and output files, time be sent and done, type of job, and annotation.
    Output:void
    Function:updata the process information table.
 **/
  public void updateclient( String job, String id, String inputf, String outputf , String times, String timed, String type, String ann) {

    System.out.println( "Update process:" + job);
    try{
      // binding input parameters to SQL call
     String s1 = "update  process_idtable " + "set  inputf = ?, outputf =?, times = ?, timed = ?, type = ?, annotation = ?" + "where id = ? ";
     PreparedStatement pstmt = conn.prepareStatement( s1 );
     pstmt.setString(1, inputf);
     pstmt.setString(2, outputf );
     pstmt.setString( 3, times );
     pstmt.setString( 4, timed );
     pstmt.setString( 5, type );
     pstmt.setString( 6, ann ); 
     pstmt.setInt(7, Integer.parseInt( id ));

      // Execute the SQL, ResultSet is integer
    int r = pstmt.executeUpdate( s1 );
    pstmt.close();
    }//try

    catch( Exception e )
    { System.err.println("Error in dbase");
      e.printStackTrace();
    }
  
    }//updateclient
 
 /**Input:job, id, input and output files, time be sent and done, type of job, and annotation.
    Output:void
    Function:add a process information to table.
 **/
   public void adddateclient( String job, String id, String inputf, String outputf, String times, String timed, String type, String ann) {
    System.out.println( "Add process:" + job);
    try{
      // binding input parameters to SQL call
     String s1 = "insert into process_idtable " + "(job, id, inputf, outputf, times, timed, type, annotation)" + "values ( ?,?,?,?,?,?,?,?)";
     PreparedStatement pstmt = conn.prepareStatement( s1 );
     pstmt.setString(1, job);
     pstmt.setInt(2, Integer.parseInt( id ));
     pstmt.setString(3, inputf);
     pstmt.setString(4, outputf);
     pstmt.setString(5, times);
     pstmt.setString( 6, timed );
     pstmt.setString( 7, type );
 // Execute the SQL, ResultSet is integer.
     pstmt.setString( 8, ann ); 
     int r = pstmt.executeUpdate( s1 );
     pstmt.close();
    }//try
 
    catch( Exception e )
    { System.err.println("Error in dbase");
      e.printStackTrace();
    }
 
    }//adddateclient
 

 /**Input:job and id.
    Output:void
    Function:delete a process.
 **/
   public void delete_dateclient( String last, String first ) {

    System.out.println( "Delete process:" + last);
    try{
      // binding input parameters to SQL call
     String s1 = "delete from process_idtable " + "where id = ?"; 
     PreparedStatement pstmt = conn.prepareStatement( s1 );
     pstmt.setInt(1, Integer.parseInt( first ));

 // Execute the SQL, ResultSet is integer
     int r = pstmt.executeUpdate( s1 );
     pstmt.close();
    }//try
 
    catch( Exception e )
    { System.err.println("Error in dbase");
      e.printStackTrace();
    }
 
    }//delete_dateclient

 /**Input:void.
    Output:void
    Function:close the table.
 **/

  public void close() {
    try {
      conn.close();
      System.out.println("Connection Closed");
    }
    catch (Exception e) {System.err.println("Error in closing dbase");}
  }
}

